#ifndef SOM_JH_2003
#define SOM_JH_2003

#include "conf.h"
#include "databin.h"
#include "clalg.h"
#include "clustering.h"
#include "evaluation.h"

class som:public clalg {

 private:

    // two-dimensional array of weight vectors
    USED_DATA_TYPE *** weight;

    // learning rate
    double lr;

    // neighbourhood size
    double ns;

  
 public:

    /* Constructor */
    som(conf * par, databin<USED_DATA_TYPE> * bin, evaluation * e);

    /* Destructor */
    ~som();

    /* Initialisation of weight vectors */
    void init();
    
    /* Training phase */
    void run();

    /* Classification phase */
    void classify(); /* 1D SOM */
    void constructmapping();  /* 2D SOM */

    double square(double x);

    void permutation();

};





#endif
